



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>从零开始学Kotlin-枚举（9）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">从零开始学Kotlin-枚举（9）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-21 03:39:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3><a href="https://github.com/SiberiaDante/KotlinForAndroid" rel="external nofollow noreferrer">从零开始学Kotlin基础篇系列文章</a></h3>
<h2>枚举的定义</h2>
<ul><li>一个类的对象是有限且固定的，这种实例有限且固定的类称为枚举类;</li>
<li>枚举常量用逗号分隔,每个枚举常量都是一个对象;</li></ul>
<pre class="prettyprint linenums"><code>    enum class EnumDemo9 {<br />
        RED, BLUE, BLACK, WHITE<br />
    }<br />
</code></pre>
<h2>枚举初始化</h2>
<ul><li>每一个枚举都是枚举类的实例，它们可以被初始化;枚举类的主构造函数默认是私有的,初始化时需要在主构造函数中声明;</li></ul>
<pre class="prettyprint linenums"><code>    enum class EnumDemo91(val rgb: Int) {<br />
        RED(0xff0000),<br />
        BLUE(0x0011ff),<br />
        BLACK(0x000000),<br />
        WHITE(0xffffff),<br />
    }<br />
</code></pre>
<h2>枚举的使用</h2>
<ul><li>EnumClass.valueOf(value: String): 由枚举值的名称获取枚举实例；未匹配成功，会抛出IllegalArgumentException</li>
<li>EnumClass.values(): 以数组的形式，获取所有的枚举实例</li></ul>
<pre class="prettyprint linenums"><code>    fun main(args: Array&lt;String&gt;) {<br />
        var colors: Array&lt;EnumDemo91&gt; = EnumDemo91.values()<br />
        var redColor = EnumDemo91.valueOf(&quot;RED&quot;)<br />
    }<br />
</code></pre>
<ul><li>每个枚举常数值都拥有属性,获取枚举相关信息:</p>
<ul><li>val name: String //获取枚举名称</li>
<li>val ordinal: Int //获取枚举值在所有枚举数组中定义的顺序</li></ul></li></ul>
<pre class="prettyprint linenums"><code>    fun main(args: Array&lt;String&gt;) {<br />
        val redColor = EnumDemo91.valueOf(&quot;RED&quot;)<br />
        var redColorName = redColor.name<br />
        var redColorOrdinal = redColor.ordinal<br />
    }<br />
</code></pre>
<ul><li>自 Kotlin 1.1 起，可以使用 enumValues() 和 enumValueOf() 函数以泛型的方式访问枚举类中的常量</li></ul>
<pre class="prettyprint linenums"><code>    print(enumValues&lt;EnumDemo91&gt;().joinToString { it.name })//输出：RED,BLUE,BLACK,WHITE<br />
    print(enumValueOf&lt;EnumDemo91&gt;(&quot;RED&quot;))//输出：RED<br />
</code></pre>
<h2>枚举类与接口</h2>
<ul><li>枚举类实现接口的情况与抽象方法类似，所有的枚举常量都应在其匿名类中实现接口的方法。</li></ul>
<pre class="prettyprint linenums"><code>    //定义一个接口<br />
    interface ItemClickListener {<br />
         fun onClick(msg: String)<br />
    }<br />
    //枚举类继承接口<br />
    enum class EnumDemo92 : ItemClickListener {<br />
        BUTTON {<br />
            override fun onClick(msg: String) {<br />
                print(msg)<br />
            }<br />
        },<br />
        IMAGE {<br />
            override fun onClick(msg: String) {<br />
                print(msg)<br />
            }<br />
        }<br />
    }<br />
</code></pre>
<h2>匿名类与抽象方法</h2>
<ul><li>枚举还支持以声明自己的匿名类及相应的方法、以及覆盖基类的方法;</li></ul>
<blockquote><ul><li>在枚举类中声明了抽象方法，所有的枚举常量都应声明其匿名类，并在匿名类中实现枚举类中声明的抽象方法，如果不实现，编译器会报错;</li>
<li>如果枚举类定义任何成员，要使用分号将成员定义中的枚举常量定义分隔开;</li>
<li>匿名内部类中声明的方法，并不能在外部使用，即使是其枚举类型的实例，也不可调用;但重写的枚举类中声明的方法，可以被其实例调用;</li></ul></blockquote>
<pre class="prettyprint linenums"><code>    enum class Person(var code: Int) {<br />
        NAME1(0) {<br />
            override fun showName(name: String): Person {<br />
                return Person.values()[0]<br />
            }<br />
        },<br />
        NAME2(1) {<br />
            override fun showName(name: String): Person = NAME2<br />
        };

        abstract fun showName(name: String): Person<br />
    }<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8ml5mp9.html">js&comma;jquery获取浏览器信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq42ly59.html">HDU 1823 Luck and Love（二维线段树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnxkwg9.html">XML文件操作（C&num;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd2l779.html">SQL SERVER 服务启动后停止，某些服务由其它服务或程序使用时将自动停止</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v751m8.html">C&num; 单例模式Lazy&amp;lt&semi;T&amp;gt&semi;实现版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdegez8.html">三星 PMU NXE2000，x-powers的AXP228，NXE2000</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mverjq.html">&lbrack;翻译&rsqb; GVUserDefaults</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j06xxlq.html">Eclipse闪退&sol;打不开&sol;无法启动&sol;一闪而过</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1gzvr9.html">【原创】贴片电容的测量方法。。。这是我从自己QQ空间转过来的，本人实操！</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdjrl78.html">SQL Server 判断表中是否存在某字段</a>
		</li>
						<li><a href="https://www.batexi.com/a/8med3zrq.html">zf-关于平台的用户名密码的设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljpdm69.html">71、django之Ajax续</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdydkk9.html">CentOS7 修改网卡名称为eth0</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojey21q.html">swift学习 引入三方遇到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw0j109.html">解决Ubuntu无法通过ssh远程登录问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jy7rnq.html">Codeforces Round &num;350 &lpar;Div&period; 2&rpar; C&period; Cinema</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j4nx5q.html">RPC框架-RMI、RPC和CORBA的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllnpyxq.html">MySQL忘记root密码的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m26rm0q.html">javascript 原生常用api 数组方法大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjeyzjq.html">net mvc webapi 实用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ko0oz5q.html">php请求API接口方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkgvjv8.html">ERC 725 and ERC 735 的实现及关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ex73j9.html">linux问题整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kdmp3q.html">PAT B1010 一元多项式求导 （25 分）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmjpxw9.html">&dollar;Simpson&dollar;积分入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnz0eeq.html">腾讯笔试题 构造回文（LCS问题）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2wymv8.html">Spark SQL -- Hive</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7exd419.html">2&period;2《想成为黑客，不知道这些命令行可不行》&lpar;Learn Enough Command Line to Be Dangerous&rpar;&mdash;&mdash;列表</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj0gpzq.html">Linux服务-openssh</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvw632q.html">基于TLS证书手动部署kubernetes集群&lpar;上&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
